#include <image.h>
#include <OS.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

int main (int argc, const char *argv[])
{
  if (argc != 2)
  {
    printf ("Usage: %s 0|1\n"
      "Use 0 to test with system running /bin/date,\n"
      "Use 1 to test with load_image() running /bin/date.\n"
      "Redirect output to a file for faster performance.\n",
      argv[0]);
    return 0;
  }
  int UseLoadImage = atoi (argv[1]);
  fprintf (stderr, "Using %s to run /bin/date repeatedly, will it fail?\n",
    UseLoadImage ? "load_image()" : "system()" );

  for (int i = 0; i < 1000000 ; i++)
  {
    fprintf (stderr, "%d ", i);
    if (UseLoadImage)
    {
      const char *Arguments[2];
      Arguments[0] = "/bin/date";
      Arguments[1] = NULL;

      thread_id NewProgramID =
        load_image (1 /* ArgumentCount */, Arguments,
        const_cast<const char **>(environ));

      resume_thread (NewProgramID);
      status_t ExitCode = -1;
      wait_for_thread (NewProgramID, &ExitCode);
    }
    else
      system ("/bin/date");

    snooze (1000);
  }
  printf ("Finished!\n"); 
  fprintf (stderr, "Finished!\n"); 
  return 0;
}
